'GPS reading and displaying for debugging.

CON
  _clkmode = XTAL1 + PLL16x
  _xinfreq = 5_000_000

'REC_FROM_GPS_PIN = 17
'sd_DO = 0
'sd_CLK = 1
'sd_DI = 2
'sd_CS = 3

OBJ
gps   : "GPS_IO_mini"
debug : "FullDuplexSerial"
sd : "fsrw"



var
long ret_val, index, acc, adc_result, voltage, scratch, adc_float, bat_tmr, numofsats, temp 
long blink_stack[20],int_stack[20], sizeoffile, write_landmark, cogbutton,cntr
byte STRsats[2]
byte signal[5]
byte lat_and_long[15]

con
slope = 0.0078046
offset = 5.8263202
Green_LED = 11
Blue_LED = 12
Button = 15

'DAT
'FileName  byte "Log01.txt",0

pub main
cntr:=0
write_landmark := 0
ret_val := -1
index := 0
bat_tmr := 0
repeat until (ret_val == 0)  
    ret_val := \sd.mount(0) ' NOTE THAT EVERY MOUNT CAUSES COGNEW TO BEGIN SAFE-SPI IN A NEW COG. unmount stops the cog
    index++                 ' THERE IS NO UNMOUNT USED.  
    waitcnt(clkfreq + cnt)
gps.start(17, 4800)       'start gps receive and parse
debug.Start(31, 30, 0, 115200)
'cognew(blink_sats, @blink_stack)   'Blinks number of satellites on Blue LED.
coginit(7,interrupt, @int_stack)

OUTA[Green_LED] := 0
DIRA[Green_LED] := 1  ' output for status LED.
DIRA[Blue_LED] := 1 
repeat 5
   outa[Green_LED] := 1                    'to catch resets.
   waitcnt(clkfreq/200 + cnt)
   outa[Green_LED] := 0
   waitcnt(clkfreq/10 + cnt)
   
waitcnt (clkfreq + cnt)   ' wait for 1sec to allow other cogs to init.

 
repeat
    
    debug.dec(clkfreq)
    debug.str(string(" ",13,10))
   if cntr > 5
      cntr := 0
      outa[Green_LED] := 1              'Blink LED for success.  
      waitcnt(clkfreq/100 + cnt)
      outa[Green_LED] := 0
      BYTEMOVE (@signal, gps.valid,1)     'gps.valid points to result in array
      'write_sd(2)
      if  signal[0] == 65        'LOGGING INFO
        write_sd(2)
      'debug_serial
{{  
          debug.str(gps.GPSaltitude)
          debug.str(string(", "))
          debug.str(gps.latitude)
          debug.str(string(", -"))
          debug.str(gps.longitude)
          debug.str(string(", "))
          debug.str(gps.satellites)
          debug.str(string(", "))
          debug.str(gps.valid)
          debug.str(string(", "))
          debug.str(gps.time)
          debug.str(string(", "))
          debug.str(gps.heading)
          debug.str(string(", "))
          debug.str(gps.speed)
          debug.str(string(", "))
          debug.str(gps.date)
          debug.str(string(", "))
          debug.tx(13)
          debug.tx(10)

}}
{{
              'debug.str(string("A DETECTED"))
          ret_val := \sd.popen(string("Log01.txt"),"a")
          \sd.SDstr(gps.GPSaltitude)
          \sd.SDstr(string(", "))
          \sd.SDstr(gps.latitude)
          \sd.SDstr(string(", -"))
          \sd.SDstr(gps.longitude)
          \sd.SDstr(string(", "))
          \sd.SDstr(gps.satellites)
          \sd.SDstr(string(", "))
          \sd.SDstr(gps.valid)
          \sd.SDstr(string(", "))
          \sd.SDstr(gps.time)
          \sd.SDstr(string(", "))
          \sd.SDstr(gps.heading)
          \sd.SDstr(string(", "))
          \sd.SDstr(gps.speed)
          \sd.SDstr(string(", "))
          \sd.SDstr(gps.date)
          \sd.SDstr(string(" ",13,10))
          \sd.pflush
          \sd.pclose
      
          if ret_val == 0
            outa[Green_LED] := 1              'Blink LED for success.  
            waitcnt(clkfreq/200 + cnt)
            outa[Green_LED] := 0

          if ret_val <> 0        'IF THE SD CARD RETURNS PROBLEMS THEN TRY TO MOUNT AGAIN. 
             index := 0
              repeat until (ret_val == 0) OR (index > 10)
              ret_val := \sd.mount(0)
              outa[Green_LED] := 1
              waitcnt(clkfreq + cnt)
              outa[Green_LED] := 0
              index++
}}
PUB interrupt
repeat
  waitcnt(80_000_000 + cnt)
  cntr++

pub  blink_sats  | sats
sats := 0
dira[Blue_LED] := 1
outa[Blue_LED] := 0
  repeat
    waitcnt(clkfreq*5 + cnt)
    sats := numofsats
    if (sats > 0) and  (sats < 13)
      repeat while (sats > 0)
        outa[Blue_LED] := 1
        waitcnt(clkfreq/200 + cnt)
        outa[Blue_LED] := 0
        waitcnt(clkfreq/2 + cnt)
        sats := sats - 1
        if sats < 1
          sats := 0



        
pub write_sd(landmark)  |address, i

  ret_val := \sd.popen(string("Log01.txt"),"a")
      if landmark == 2
          \sd.SDstr(gps.GPSaltitude)
          \sd.SDstr(string(", "))

          'bytefill(@lat_and_long,0,15)  'Clear Buffer
          address := gps.latitude   'Get address of latitude
          byte[@lat_and_long][0] := byte[address][0]
          byte[@lat_and_long][1] := byte[address][1]
          byte[@lat_and_long][2] := " "
          i := 3
          repeat 7
            byte[@lat_and_long][i] := byte[address][i-1]
            i++
          byte[@lat_and_long][i] := 0  
          \sd.SDstr(lat_and_long)
          \sd.SDstr(string("N, "))
          
          'bytefill(@lat_and_long,0,15)  'Clear Buffer
          address := gps.longitude   'Get address of longitude
          byte[@lat_and_long][0] := byte[address][1]
          byte[@lat_and_long][1] := byte[address][2]
          byte[@lat_and_long][2] := " "
          i := 3
          repeat 7
            byte[@lat_and_long][i] := byte[address][i]
            i++
          byte[@lat_and_long][i] := 0   
          \sd.SDstr(lat_and_long)

          \sd.SDstr(string("W, ")) 
          \sd.SDstr(gps.satellites)
          \sd.SDstr(string(", "))
          \sd.SDstr(gps.valid)
          \sd.SDstr(string(", "))
          \sd.SDstr(gps.time)
          \sd.SDstr(string(", "))
          \sd.SDstr(gps.heading)
          \sd.SDstr(string(", "))
          \sd.SDstr(gps.speed)
          \sd.SDstr(string(", "))
          \sd.SDstr(gps.date)
          \sd.SDstr(string(" ",13,10))
          'debug.str(string("test"))
          'debug.dec(ret_val)
          'debug.tx(13) 
          \sd.pflush
          \sd.pclose
          'debug.str(string("after file close",13,10))
         

      if landmark == 1
          \sd.SDstr(gps.GPSaltitude)
          \sd.SDstr(string(", "))
          \sd.SDstr(gps.latitude)
          \sd.SDstr(string(", -"))
          \sd.SDstr(gps.longitude)

          
          \sd.SDstr(string(", "))
          \sd.SDstr(gps.satellites)
          \sd.SDstr(string(", "))
          \sd.SDstr(gps.valid)
          \sd.SDstr(string(", "))
          \sd.SDstr(gps.time)
          \sd.SDstr(string(", "))
          \sd.SDstr(gps.heading)
          \sd.SDstr(string(", "))
          \sd.SDstr(gps.speed)
          \sd.SDstr(string(", "))
          \sd.SDstr(gps.date)
          \sd.SDstr(string(", Landmark"))
          \sd.SDstr(string(" ",13,10))
          'debug.str(string("test"))
          'debug.dec(ret_val)
          'debug.tx(13) 
          \sd.pflush
          \sd.pclose

      if ret_val == 0
        outa[Green_LED] := 1              'Blink LED for success.  
        waitcnt(clkfreq/100 + cnt)
        outa[Green_LED] := 0

      if ret_val <> 0  
        outa[Blue_LED] := 1              'Blink LED for NOT success.  
        waitcnt(clkfreq/2 + cnt)
        outa[Blue_LED] := 0

{{
      if ret_val <> 0        'IF THE SD CARD RETURNS PROBLEMS THEN TRY TO MOUNT AGAIN. 
         index := 0
          repeat until (ret_val == 0) OR (index > 10)
          ret_val := \sd.mount(0)
          outa[Green_LED] := 1
          waitcnt(clkfreq + cnt)
          outa[Green_LED] := 0
          index++
}}
pub debug_serial
   debug.str(gps.GPSaltitude)
   debug.str(string(", "))
   debug.str(gps.latitude)
   debug.str(string(", -"))
   debug.str(gps.longitude)
   debug.str(string(", "))
   debug.str(gps.satellites)
   debug.str(string(", "))
   debug.str(gps.valid)
   debug.str(string(", "))
   debug.str(gps.time)
   debug.str(string(", "))
   debug.str(gps.heading)
   debug.str(string(", "))
   debug.str(gps.speed)
   debug.str(string(", "))
   debug.str(gps.date)
   debug.str(string(", "))
   debug.tx(13)
   'debug.tx(10)

  




    
 
  